/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.smartitengineering.demo.selectionsuite.myeditor.books;

import com.smartitengineering.demo.selectionsuite.multivieweditor.BookEditAction;
import com.smartitengineering.demo.selectionsuite.api.book.BookNode;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.logging.Logger;
import org.openide.explorer.ExplorerUtils;
import org.openide.nodes.AbstractNode;
import org.openide.util.Lookup;
import org.openide.util.LookupEvent;
import org.openide.util.LookupListener;
import org.openide.util.NbBundle;
import org.openide.util.Utilities;
import org.openide.util.lookup.AbstractLookup;
import org.openide.util.lookup.InstanceContent;
import org.openide.util.lookup.ProxyLookup;
import org.openide.windows.TopComponent;
import org.openide.windows.WindowManager;
//import org.openide.util.Utilities;
/**
 * Top component which displays something.
 */
final class BookViewTopComponent
    extends TopComponent {

    private static BookViewTopComponent instance;
    /** path to the icon used by the component and its open action */
    static final String ICON_PATH = "com/smartitengineering/demo/selectionsuite/myeditor/1062053772786.gif";
    private static final String PREFERRED_ID = "BookViewTopComponent";
    private InstanceContent customNodeContent;
    private AbstractLookup bookViewLookup;
    private ProxyLookup componentLookup;
    private final Lookup authorLookup;
    private Lookup bookLookup;
    private Lookup.Result<BookNode> bookResult;
    private LookupListener authorViewUpdater;
    private LookupListener bookLookupPublisher;
    private final HashSet<BookNode> addedContent;
    private static BookEditAction ACTION = new BookEditAction();

    private BookViewTopComponent() {
        initComponents();
        setName(NbBundle.getMessage(BookViewTopComponent.class,
            "CTL_BookViewTopComponent"));
        setToolTipText(NbBundle.getMessage(BookViewTopComponent.class,
            "HINT_BookViewTopComponent"));
        AbstractNode rootBookNode = new AbstractNode(BookNode.
            getRootBookChildren(ACTION));
        rootBookNode.setHidden(true);
        rootBookNode.setIconBaseWithExtension("com/smartitengineering/demo/selectionsuite/myapi/book.gif");
        bookExplorer.getExplorerManager().setRootContext(rootBookNode);

        customNodeContent = new InstanceContent();
        bookViewLookup = new AbstractLookup(customNodeContent);
        authorLookup =
            ExplorerUtils.createLookup(authorExplorer.getExplorerManager(),
            authorExplorer.getActionMap());
        componentLookup = new ProxyLookup(bookViewLookup, authorLookup);
        associateLookup(componentLookup);

        addedContent = new HashSet<BookNode>();

        setIcon(Utilities.loadImage(ICON_PATH, true));
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        bookExplorer = new com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel();
        bookListView = new org.openide.explorer.view.ListView();
        authorExplorer = new com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel();
        authorListView = new org.openide.explorer.view.ListView();

        javax.swing.GroupLayout bookExplorerLayout = new javax.swing.GroupLayout(bookExplorer);
        bookExplorer.setLayout(bookExplorerLayout);
        bookExplorerLayout.setHorizontalGroup(
            bookExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(bookExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(bookListView, javax.swing.GroupLayout.DEFAULT_SIZE, 221, Short.MAX_VALUE)
                .addContainerGap())
        );
        bookExplorerLayout.setVerticalGroup(
            bookExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(bookExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(bookListView, javax.swing.GroupLayout.DEFAULT_SIZE, 295, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout authorExplorerLayout = new javax.swing.GroupLayout(authorExplorer);
        authorExplorer.setLayout(authorExplorerLayout);
        authorExplorerLayout.setHorizontalGroup(
            authorExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(authorExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(authorListView, javax.swing.GroupLayout.DEFAULT_SIZE, 232, Short.MAX_VALUE)
                .addContainerGap())
        );
        authorExplorerLayout.setVerticalGroup(
            authorExplorerLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(authorExplorerLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(authorListView, javax.swing.GroupLayout.DEFAULT_SIZE, 295, Short.MAX_VALUE)
                .addContainerGap())
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(this);
        this.setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(bookExplorer, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                .addComponent(authorExplorer, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(bookExplorer, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(authorExplorer, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
    }// </editor-fold>//GEN-END:initComponents
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel authorExplorer;
    private org.openide.explorer.view.ListView authorListView;
    private com.smartitengineering.demo.selectionsuite.myeditor.ExplorerPanel bookExplorer;
    private org.openide.explorer.view.ListView bookListView;
    // End of variables declaration//GEN-END:variables
    /**
     * Gets default instance. Do not use directly: reserved for *.settings files only,
     * i.e. deserialization routines; otherwise you could get a non-deserialized instance.
     * To obtain the singleton instance, use {@link findInstance}.
     */
    public static synchronized BookViewTopComponent getDefault() {
        if (instance == null) {
            instance = new BookViewTopComponent();
        }
        return instance;
    }

    /**
     * Obtain the BookViewTopComponent instance. Never call {@link #getDefault} directly!
     */
    public static synchronized BookViewTopComponent findInstance() {
        TopComponent win = WindowManager.getDefault().findTopComponent(
            PREFERRED_ID);
        if (win == null) {
            Logger.getLogger(BookViewTopComponent.class.getName()).warning(
                "Cannot find " + PREFERRED_ID +
                " component. It will not be located properly in the window system.");
            return getDefault();
        }
        if (win instanceof BookViewTopComponent) {
            return (BookViewTopComponent) win;
        }
        Logger.getLogger(BookViewTopComponent.class.getName()).warning(
            "There seem to be multiple components with the '" + PREFERRED_ID +
            "' ID. That is a potential source of errors and unexpected behavior.");
        return getDefault();
    }

    @Override
    public int getPersistenceType() {
        return TopComponent.PERSISTENCE_ALWAYS;
    }

    @Override
    public void componentOpened() {
        if (bookLookup == null) {
            bookLookup = ExplorerUtils.createLookup(
                bookExplorer.getExplorerManager(), bookExplorer.getActionMap());
        }

        Lookup.Template<BookNode> bookTemplate = new Lookup.Template<BookNode>(
            BookNode.class);
        bookResult = bookLookup.lookup(bookTemplate);

        authorViewUpdater = new LookupListener() {

            public void resultChanged(LookupEvent nodeEvent) {
                List<? extends BookNode> nodes = new ArrayList<BookNode>(
                    ((Lookup.Result<BookNode>) nodeEvent.getSource()).
                    allInstances());
                if (nodes != null && !nodes.isEmpty()) {
                    authorExplorer.getExplorerManager().setRootContext(
                        nodes.get(0).getCompleteBookNode());
                }
            }
        };
        bookResult.addLookupListener(authorViewUpdater);

        bookLookupPublisher = new LookupListener() {

            public synchronized void resultChanged(LookupEvent nodeEvent) {
                List<? extends BookNode> nodes = new ArrayList<BookNode>(
                    ((Lookup.Result<BookNode>) nodeEvent.getSource()).
                    allInstances());
                for (BookNode node : addedContent) {
                    customNodeContent.remove(node);
                }
                addedContent.clear();
                if (nodes != null && !nodes.isEmpty()) {
                    for (BookNode node : nodes) {
                        if (node != null) {
                            if (node.isPublished() &&
                                (node.isEbookAvailable() ||
                                node.getStockAmount() > 0)) {
                                addedContent.add(node);
                            }
                        }
                    }
                }
                for (BookNode node : addedContent) {
                    customNodeContent.add(node);
                }
            }
        };
        bookResult.addLookupListener(bookLookupPublisher);

        bookResult.allInstances();
    }

    @Override
    public void componentClosed() {
        bookResult.removeLookupListener(authorViewUpdater);
        bookResult.removeLookupListener(bookLookupPublisher);
    }

    /** replaces this in object stream */
    @Override
    public Object writeReplace() {
        return new ResolvableHelper();
    }

    @Override
    protected String preferredID() {
        return PREFERRED_ID;
    }

    final static class ResolvableHelper
        implements Serializable {

        private static final long serialVersionUID = 1L;

        public Object readResolve() {
            return BookViewTopComponent.getDefault();
        }
    }
}
